<?php
// BACKEND API ERROR FUNCTIONS
//
// Copyright (c) 2008-2014 Nagios Enterprises, LLC.  All rights reserved.
//  
// $Id: errors.inc.php 2561 2014-04-30 18:39:36Z jomann $

require_once(dirname(__FILE__).'/common.inc.php');

////////////////////////////////////////////////////////////////////////
// ERROR HANDLING FUNCTIONS
////////////////////////////////////////////////////////////////////////

// Returns an formatted error
function handle_backend_error($msg)
{
    global $request;
    output_backend_header();

    // Grab the type and return based on that
    $outputtype = strtolower(grab_request_var("outputtype", "xml"));
    if ($outputtype == "json") {
        $data = array("error" => 1,
                      "message" => $msg);
        print backend_output($data);
    } else {
        echo "<error>\n<errormessage>$msg</errormessage>\n</error>\n";
    }
    exit;
}

// Handles database errors
function handle_backend_db_error($dbh="")
{
    global $DB;
    
    $errmsg = "";
    if (have_value($dbh)) {
        $errmsg = $DB[$dbh]->ErrorMsg();
    }

    handle_backend_error("DB Error: " . $errmsg);
}
