<?php  //delete_object.php




/** function delete_object() 
*	deletes a single object configuration from the nagiosql database, also removes relations 
*	@param string $table the appropriate object database table
*	@param int $id the object id/primary key for the nagios object 
*	@global object $myDataClass nagiosql data handler
*	@return array array(int $intReturn, string $strMessage) return data for browser output 
*/ 
function delete_object($table,$id,$audit=false) 
{
	global $myDataClass;
	global $ccmDB;
	global $myDBClass; 
	global $myConfigClass;
	
	//bail if missing id 
	if(!$id) 
		return gettext("Cannot delete data, no object ID specified!")."<br />"; 
	
	if($table=='log') $table = 'logbook'; 	

	$strMessage = ''; 
	
	// Check to see if it is a service or host and get the config_name or host_name of the object
	// This will be used below to delete the config file if necessary.
	if ($table == "host") {
		$strSQL  = "SELECT `id`,`host_name` FROM `tbl_host` WHERE `id` = $id AND `active`='1'";
		$myDBClass->getDataArray($strSQL,$arrData,$intDataCount);
	
	} elseif ($table == "service") {
		$strSQL  = "SELECT `id`,`config_name` FROM `tbl_service` WHERE `id` = $id AND `active`='1'";
		$myDBClass->getDataArray($strSQL,$arrData,$intDataCount);
	}
	
	$intReturn = $myDataClass->dataDeleteFull("tbl_".$table,$id,0,$audit);
	$strMessage .= $myDataClass->strDBMessage;
	if($audit)
		audit_log(AUDITLOGTYPE_DELETE,$strMessage);
	
	// If the above row delete was successful, remove the corresponding config file
	if ($intReturn == 0 && $arrData && $table == "host") {
		$myConfigClass->getConfigData("hostconfig",$strHostDir);
		$cmdline="rm -f \"".$strHostDir.$arrData[0]['host_name'].".cfg\"";
		$output=system($cmdline,$return_code);
	} elseif ($intReturn == 0 && $arrData && $table == "service") {
		$myConfigClass->getConfigData("serviceconfig",$strServiceDir);
		$cmdline="rm -f \"".$strServiceDir.$arrData[0]['config_name'].".cfg\"";
		$output=system($cmdline,$return_code);
	} 
		
	//return success or failure message 
	return array($intReturn,$strMessage); 
}



/** function delete_multi() 
*	deletes multiple object configurations from the nagiosql database, also removes relations 
*	@param string $table the appropriate object database table
*	@global array $_REQUEST['checked'] array of $ids of the objects, id/primary key for the nagios object 
*	@return array array(int $intReturn, string $strMessage) return data for browser output 
*/ 
function delete_multi($table)
{
	$checks = ccm_grab_request_var('checked',array()); 
	//delete all checked objects 
	$failMessage= ''; 
	$itemsDeleted = 0; 
	$itemsFailed = 0; 
	foreach($checks as $c)
	{
		$r = delete_object($table,$c,false); 
		if($r[0]==0) $itemsDeleted++; 
		else 
		{
			$itemsFailed++; 
			$failMessage .= $r[1]; //append DB return messages 	
		}	
	}	
	
	$intReturn = 0;
	$returnMessage = ''; 
	if($itemsFailed ==0 && $itemsDeleted==0) $returnMessage .= gettext("No items were deleted from the database.")."<br />"; 
	if ($itemsDeleted > 0) $returnMessage .= $itemsDeleted." ".gettext("items deleted from database")."<br />"; 
	if($itemsFailed > 0) 
	{
		$returnMessage .= "<strong>".$itemsFailed." ".gettext("items failed to delete.")."</strong><br />
													".gettext("Items may have dependent relationships that prevent deletion").".<br /> 
													".gettext("Use the 'info'  button to see all relationships.")."
													<img src='/nagiosql/images/info.gif' alt='' /><br />   
													$failMessage"; 
		$intReturn = 1; 	
	}	
	
	//audit log
	if($itemsDeleted > 0)
		audit_log(AUDITLOGTYPE_DELETE,$returnMessage);
	
	//return success or failure message 
	return array($intReturn,$returnMessage); 
}




?>
